#include "grafi.h"

//_________ZONAS_____________
int DetecZonas(int x, int y)
{
int z;
	for(z=0;z<MAXZONAS && nzona[z].numero!=-1 ;z++)
	{
		if( x>nzona[z].x && y>nzona[z].y && x<(nzona[z].x+nzona[z].w) && y<(nzona[z].y+nzona[z].h))
			return z;
	}
return -1;

}


//__________TEXTOS______________
void PaintText(int x,int y,int w,int h,char *texto,unsigned char tipo,int clase)
{

 SDL_Surface *message;

	message = TTF_RenderText_Solid( font,texto, textColor );
	apply_surface( x+28, y+2, message, screen );
}

void PaintTex(int numero,int modo)
{
	PaintText(ntexto[numero].x,ntexto[numero].y,ntexto[numero].w,ntexto[numero].h,ntexto[numero].nombre,modo,ntexto[numero].numero);
}

void PaintTextos()
{
	int x;
	for(x=0;x<MAXTEXTOS && ntexto[x].numero!=-1 ;x++)
	{
		if(ntexto[x].estado==0)
			PaintTex(x,0);
		 else
			PaintTex(x,1);
	}
}	



//______________BOTONES___________________________



void Paintbutton(int x,int y,int w,int h,char *texto,unsigned char tipo)
{
  int w1,h1;
 SDL_Rect clip[ 1 ];
 SDL_Surface *message;
	if(tipo==0)
	{
		clip[ 0 ].x = 0;
	    clip[ 0 ].y = 0;
    	clip[ 0 ].w = 89;
    	clip[ 0 ].h = 25;
	}
	else
	{
		clip[ 0 ].x = 89;
	    clip[ 0 ].y = 0;
    	clip[ 0 ].w = 89;
    	clip[ 0 ].h = 25;		
	}
 	apply_surfaceB( x, y, dots, screen, &clip[ 0 ] );
	message = TTF_RenderText_Solid( font,texto, textColor );
	if(TTF_SizeText(font,texto,&w1,&h1))
		{
			printf("Error tamaño texto");
		} 
		else
		{
			w1=w1/2;
			w1=45-w1;
			if(w1<0)w1=0;
		}	
	apply_surface( x+w1, y+2, message, screen );
}	


void PaintBoton(int numero,int modo)
{
  if(nboton[numero].estado!=-1)Paintbutton(nboton[numero].x,nboton[numero].y,nboton[numero].w,nboton[numero].h,nboton[numero].nombre,modo);	
}

void PaintBotones()
{
 int x;
	for(x=0;x<MAXBOTONES && nboton[x].numero!=-1 ;x++)PaintBoton(x,0);
}	

int DetecBotones(int x, int y)
{
int z;
	for(z=0;z<MAXBOTONES && nboton[z].numero!=-1 ;z++)
	{
		if(nboton[z].estado!=-1 && x>nboton[z].x && y>nboton[z].y && x<(nboton[z].x+nboton[z].w) && y<(nboton[z].y+nboton[z].h))
			return z;
	}
return -1;

}

//_____________________________________

void PaintLight(int x,int y,int w,int h,char *texto,unsigned char tipo,int clase)
{
 SDL_Rect clip[ 1 ];
 SDL_Surface *message;
   if(tipo==0)
	{
		clip[ 0 ].x = 0;
    	clip[ 0 ].y = 25;
    	clip[ 0 ].w = 89;
    	clip[ 0 ].h = 25;	
	}
	else
	{
		if(clase==2)
		   {
			clip[ 0 ].x = 89;
    		clip[ 0 ].y = 25;
    		clip[ 0 ].w = 89;
    		clip[ 0 ].h = 25;			
		   }

		if(clase==3)
		   {
			clip[ 0 ].x = 0;
    		clip[ 0 ].y = 75;
    		clip[ 0 ].w = 89;
    		clip[ 0 ].h = 25;			
		   }
	
	}
	apply_surfaceB( x, y, dots, screen, &clip[ 0 ] );
	message = TTF_RenderText_Solid( font,texto, textColor );
	apply_surface( x+28, y+2, message, screen );
}

void PaintLuz(int numero,int modo)
{
	PaintLight(nluz[numero].x,nluz[numero].y,nluz[numero].w,nluz[numero].h,nluz[numero].nombre,modo,nluz[numero].numero);
}

void PaintLuces()
{
	int x;
	for(x=0;x<MAXLUCES && nluz[x].numero!=-1 ;x++)
	{
	   if(nluz[x].enable==1)
	    {   
		if(nluz[x].estado==0)
			PaintLuz(x,0);
		 else
			PaintLuz(x,1);
		 
	    }
	}
}	
//_____________________________________________



void PaintInput(int x,int y,int w,int h,char *texto,unsigned char tipo)
{
 SDL_Rect clip;
 SDL_Surface *message;
		clip.x = x;
    	clip.y = y;
    	clip.w = w;
    	clip.h = h;	

	SDL_FillRect( screen, &clip, SDL_MapRGB( screen->format, 0xFF, 0xFF, 0xFF ) );
	message = TTF_RenderText_Solid( font,texto, textColor );
	apply_surface( x+2, y+2, message, screen );
}


void PaintEntrada(int numero,int modo)
{
	if(nentrada[numero].estado!=-1) PaintInput(nentrada[numero].x,nentrada[numero].y,nentrada[numero].w,nentrada[numero].h,nentrada[numero].nombre,modo);
}

void PaintEntradas()
{
 int x;
	for(x=0;x<MAXENTRADAS && nentrada[x].numero!=-1 ;x++)
		if(nentrada[x].enable==1)PaintEntrada(x,0);
}	


void TextEntrada(int numero,char *s)
{
	PaintInput(nentrada[numero].x,nentrada[numero].y,nentrada[numero].w,nentrada[numero].h,s,0);
}	

//_______n________________________________________

int init()
{
    if( SDL_Init( SDL_INIT_EVERYTHING ) == -1 )  return 0;
 //   screen = SDL_SetVideoMode( SCREEN_WIDTH, SCREEN_HEIGHT, SCREEN_BPP,SDL_FULLSCREEN | SDL_SWSURFACE );
    screen = SDL_SetVideoMode( SCREEN_WIDTH, SCREEN_HEIGHT, SCREEN_BPP, SDL_SWSURFACE );

    if( screen == NULL )   return 0;
	
    if(TTF_Init()==-1) 
		{
    	 printf("TTF_Init: %s\n", TTF_GetError());
   		 return 0;
		}
		//Initialize SDL_mixer 
	if(SONIDO)if( Mix_OpenAudio( 22050, MIX_DEFAULT_FORMAT, 2, 4096 ) == -1 )
		{
		 printf("Error SDL Mixer_Init:");
		 return 0;
		}

    return 1;
}

void clean_up()
{
	if(SONIDO)Mix_FreeChunk(sonido);
    SDL_FreeSurface( background );
	SDL_FreeSurface( dots );
    SDL_Quit();
}



SDL_Surface *load_image( char *filename )
{ 
	SDL_Surface *temp,*ima;

	temp  =IMG_Load(filename);
	if (temp == NULL){
		printf("Error al cargar %s\n", filename);
		exit(EXIT_FAILURE);
	}			 
		ima = SDL_DisplayFormat(temp);
		SDL_FreeSurface( temp );

        if( ima != NULL )
        {
            Uint32 colorkey = SDL_MapRGB( ima->format, 0, 0xFF, 0xFF );
            SDL_SetColorKey( ima, SDL_SRCCOLORKEY, colorkey );
			if(DEBUG)printf("ok al cargar %s\n", filename);
        }
	
	return ima; 
}

void apply_surface( int x, int y, SDL_Surface* source, SDL_Surface* destination )
	{ 
		SDL_Rect offset; 
		offset.x = x;
		offset.y = y;
		SDL_BlitSurface( source, NULL, destination, &offset );
	}
void apply_surfaceB( int x, int y, SDL_Surface* source, SDL_Surface* destination,SDL_Rect* clip )
	{ 
		SDL_Rect offset; 
		offset.x = x;
		offset.y = y;
		SDL_BlitSurface( source, clip, destination, &offset );
	}
