#define YesWindows 0


#if YesWindows 
 #include <windows.h>
#else
 #include <sys/types.h>
 #include <sys/stat.h>
 #include <fcntl.h>
 #include <termios.h>
 #define BAUDRATE B9600
#endif

#include "compo.h"
#include "grafi.h"

#include "define.h"


	const int SCREEN_WIDTH = 640; 
	const int SCREEN_HEIGHT = 480; 
	const int SCREEN_BPP = 32;


	//The surfaces that will be used 
	SDL_Surface *message = NULL; 
	SDL_Surface *background = NULL;
	SDL_Surface *background2 = NULL;  
	SDL_Surface *dots = NULL;
	SDL_Surface *screen = NULL;

	TTF_Font *font = NULL;
	SDL_Color textColor = { 25, 25, 25 };

	SDL_Event event;
	Mix_Chunk *sonido;

	int TICK_INTERVAL=2000;

	char VARI[100];


//________________________
#if YesWindows 
	char MODEMDEVICEdefault[]= "COM3";
	HANDLE hSerial;
// DCB dcbSerial;
    DCB dcbSerialParams;
    COMMTIMEOUTS time_out;
#else
	char MODEMDEVICEdefault[]= "/dev/ttyUSB0";
	struct termios newtermios;
	int fdrs232;
#endif

char *MODEMDEVICE;

#if YesWindows  
int WriteSerie(HANDLE hSerial,char *c,int tamano);
int ReadSerie(HANDLE hSerial,char *c,int tamano);
#endif

int IniRs232();
int CloseRs232();
//_________________________

SDL_Surface *load_image( char *filename );
void apply_surface( int x, int y, SDL_Surface* source, SDL_Surface* destination );
void apply_surfaceB( int x, int y, SDL_Surface* source, SDL_Surface* destination,SDL_Rect* clip );
int init();
int load_files();

void Paintbutton(int x,int y,int w,int h,char *texto,unsigned char tipo);
void PaintBoton(int numero,int modo);
void PaintBotones();
int DetecBotones(int x, int y);
void Inibotones();

void PaintLight(int x,int y,int w,int h,char *texto,unsigned char tipo,int clase);
void PaintLuz(int numero,int modo);
void PaintLuces();
void IniLuces();

#if YesWindows  
int WriteSerie(HANDLE hSerial,char *c,int tamano);
int ReadSerie(HANDLE hSerial,char *c,int tamano);
#endif

void Inientradas();
void PaintInput(int x,int y,int w,int h,char *texto,unsigned char tipo);
void PaintEntrada(int numero,int modo);
void PaintEntradas();
void TextEntrada(int numero,char *s);


void PaintText(int x,int y,int w,int h,char *texto,unsigned char tipo,int clase);
void PaintTex(int numero,int modo);
void PaintTextos();

